diff -uwr sourceold/scripts/engine_obj.cpp source/scripts/engine_obj.cpp
--- sourceold/scripts/engine_obj.cpp	2012-02-17 21:03:32.721679600 +0800
+++ source/scripts/engine_obj.cpp	2012-05-23 11:24:04.913085900 +0800
@@ -29,6 +29,8 @@
 #include "TransitionGameObjDef.h"
 #include "AirFactoryGameObjDef.h"
 #include "AirFactoryGameObj.h"
+#include "NavalFactoryGameObjDef.h"
+#include "NavalFactoryGameObj.h"
 #include "AirStripGameObjDef.h"
 #include "AirStripGameObj.h"
 #include "BeaconGameObjDef.h"
@@ -58,844 +60,269 @@
 #include "WarFactoryGameObjDef.h"
 #include "WarFactoryGameObj.h"
 
-const AirFactoryGameObjDef &
+SCRIPTS_API const AirFactoryGameObjDef &
 AirFactoryGameObj::Get_Definition (void) const
 {
 	return (const AirFactoryGameObjDef &)BaseGameObj::Get_Definition ();
 }
-const AirStripGameObjDef & AirStripGameObj::Get_Definition( void ) const
+SCRIPTS_API  const NavalFactoryGameObjDef &
+NavalFactoryGameObj::Get_Definition (void) const
+{
+	return (const NavalFactoryGameObjDef &)BaseGameObj::Get_Definition ();
+}
+SCRIPTS_API  const AirStripGameObjDef & AirStripGameObj::Get_Definition( void ) const
 {
 	return (const AirStripGameObjDef &)BaseGameObj::Get_Definition();
 }
-const ArmedGameObjDef & ArmedGameObj::Get_Definition( void ) const
+SCRIPTS_API  const ArmedGameObjDef & ArmedGameObj::Get_Definition( void ) const
 {
 	return (const ArmedGameObjDef &)BaseGameObj::Get_Definition();
 }
-const BeaconGameObjDef & BeaconGameObj::Get_Definition( void ) const
+SCRIPTS_API const BeaconGameObjDef & BeaconGameObj::Get_Definition( void ) const
 {
 	return (const BeaconGameObjDef &)BaseGameObj::Get_Definition();
 }
-const C4GameObjDef & C4GameObj::Get_Definition( void ) const
+SCRIPTS_API const C4GameObjDef & C4GameObj::Get_Definition( void ) const
 {
 	return (const C4GameObjDef &)BaseGameObj::Get_Definition();
 }
-const CinematicGameObjDef & CinematicGameObj::Get_Definition( void ) const
+SCRIPTS_API const CinematicGameObjDef & CinematicGameObj::Get_Definition( void ) const
 {
 	return (const CinematicGameObjDef &)BaseGameObj::Get_Definition();
 }
-const ComCenterGameObjDef &
+SCRIPTS_API const ComCenterGameObjDef &
 ComCenterGameObj::Get_Definition (void) const
 {
 	return (const ComCenterGameObjDef &)BaseGameObj::Get_Definition ();
 }
-const ConstructionYardGameObjDef &
+SCRIPTS_API const ConstructionYardGameObjDef &
 ConstructionYardGameObj::Get_Definition (void) const
 {
 	return (const ConstructionYardGameObjDef &)BaseGameObj::Get_Definition ();
 }
-const DamageZoneGameObjDef & DamageZoneGameObj::Get_Definition( void ) const
+SCRIPTS_API const DamageZoneGameObjDef & DamageZoneGameObj::Get_Definition( void ) const
 {
 	return (const DamageZoneGameObjDef &)BaseGameObj::Get_Definition();
 }
-const PowerPlantGameObjDef &
+SCRIPTS_API const PowerPlantGameObjDef &
 PowerPlantGameObj::Get_Definition (void) const
 {
 	return (const PowerPlantGameObjDef &)BaseGameObj::Get_Definition ();
 }
-const RepairBayGameObjDef &
+SCRIPTS_API const RepairBayGameObjDef &
 RepairBayGameObj::Get_Definition (void) const
 {
 	return (const RepairBayGameObjDef &)BaseGameObj::Get_Definition ();
 }
-const SamSiteGameObjDef & SamSiteGameObj::Get_Definition( void ) const
+SCRIPTS_API const SamSiteGameObjDef & SamSiteGameObj::Get_Definition( void ) const
 {
 	return (const SamSiteGameObjDef &)BaseGameObj::Get_Definition();
 }
-const SoldierGameObjDef & SoldierGameObj::Get_Definition( void ) const
+SCRIPTS_API const SoldierGameObjDef & SoldierGameObj::Get_Definition( void ) const
 {
 	return (const SoldierGameObjDef &)BaseGameObj::Get_Definition();
 }
-const SoldierFactoryGameObjDef &
+SCRIPTS_API const SoldierFactoryGameObjDef &
 SoldierFactoryGameObj::Get_Definition (void) const
 {
 	return (const SoldierFactoryGameObjDef &)BaseGameObj::Get_Definition ();
 }
-const SpecialEffectsGameObjDef & SpecialEffectsGameObj::Get_Definition( void ) const
-{
-	return (const SpecialEffectsGameObjDef &)BaseGameObj::Get_Definition();
-}
-const TransitionGameObjDef & TransitionGameObj::Get_Definition( void ) const
-{
-	return (const TransitionGameObjDef &)BaseGameObj::Get_Definition();
-}
-const WarFactoryGameObjDef &
-WarFactoryGameObj::Get_Definition (void) const
-{
-	return (const WarFactoryGameObjDef &)BaseGameObj::Get_Definition ();
-}
-
-const VehicleFactoryGameObjDef &
-VehicleFactoryGameObj::Get_Definition (void) const
-{
-	return (const VehicleFactoryGameObjDef &)BaseGameObj::Get_Definition ();
-}
-
-const ScriptZoneGameObjDef & ScriptZoneGameObj::Get_Definition( void ) const
-{
-	return (const ScriptZoneGameObjDef &)BaseGameObj::Get_Definition();
-}
-
-unsigned char NetworkObjectClass::Get_Object_Dirty_Bits(int clientId)
-{
-	return ClientStatus[clientId];
-}
-
-bool NetworkObjectClass::Get_Object_Dirty_Bit(int clientId, DIRTY_BIT level)
-{
-	return (ClientStatus[clientId] & level) == level;
-}
-
-void DefenseObjectClass::Set_Health_Max(float health)
-{
-	HealthMax = WWMath::Clamp(health, 0, MAX_MAX_HEALTH);
-	if (HealthMax < Health)
-	{
-		Health = HealthMax;
-	}
-	Mark_Owner_Dirty();
-}
-
-void	DefenseObjectClass::Set_Shield_Type( ArmorType type )	
-{ 
-	ShieldType = type; 
-	Mark_Owner_Dirty();
-}
-
-float DefenseObjectClass::Get_Health() const
-{
-	return this->Health;
-}
-
-
-
-float DefenseObjectClass::Get_Health_Max() const
-{
-	return this->HealthMax;
-}
-
-
-float DefenseObjectClass::Get_Shield_Strength() const
-{
-	return this->ShieldStrength;
-}
-
-
-
-float DefenseObjectClass::Get_Shield_Strength_Max() const
-{
-	return this->ShieldStrengthMax;
-}
-
-void DefenseObjectClass::Set_Shield_Strength_Max(float str)
-{
-	ShieldStrengthMax = WWMath::Clamp(str, 0, MAX_MAX_SHIELD_STRENGTH);
-	if (ShieldStrengthMax < ShieldStrength)
-	{
-		ShieldStrength = ShieldStrengthMax;
-	}
-	Mark_Owner_Dirty();
-}
-
-
-
-void DefenseObjectClass::Mark_Owner_Dirty()
-{
-	if (Get_Owner())
-	{
-		Get_Owner()->Set_Object_Dirty_Bit(NetworkObjectClass::BIT_OCCASIONAL, true);
-	}
-}
-
-SCRIPTS_API REF_DEF3(GameObjManager::BuildingGameObjList, SList<BuildingGameObj>, 0x00856FE8, 0x008561D0, 0x0085BED0);
-SCRIPTS_API REF_DEF3(GameObjManager::GameObjList, SList<BaseGameObj>, 0x00856FF8, 0x008561E0, 0x0085BEE0);
-SCRIPTS_API REF_DEF3(GameObjManager::StarGameObjList, SList<SoldierGameObj>, 0x00856FC8, 0x008561B0, 0x0085BEB0);
-SCRIPTS_API REF_DEF3(GameObjManager::SmartGameObjList, SList<SmartGameObj>, 0x00856FD8, 0x008561C0, 0x0085BEC0);
-
-#ifdef SHADERS_EXPORTS
-SHADERS_API SList<C4GameObj> GameObjManager::C4GameObjList;
-SHADERS_API SList<BeaconGameObj> GameObjManager::BeaconGameObjList;
-SHADERS_API SList<SoldierGameObj> GameObjManager::SoldierGameObjList;
-SHADERS_API SList<VehicleGameObj> GameObjManager::VehicleGameObjList;
-#endif
-
-const BaseGameObjDef &	BaseGameObj::Get_Definition( void ) const 
-{
-	return *Definition;
-};
-
-const DamageableGameObjDef & DamageableGameObj::Get_Definition( void ) const 
-{
-	return (const DamageableGameObjDef &)BaseGameObj::Get_Definition();
-}
-
-void ScriptableGameObj::Insert_Observer( GameObjObserverClass * observer )
-{
-	observer->Attach( this );
-	Observers.Add( observer );
-}
-
-void ScriptableGameObj::Remove_Observer( GameObjObserverClass * observer )
-{
-	Observers.Delete( observer );
-	observer->Detach( this );
-}
-
-const ScriptableGameObjDef & ScriptableGameObj::Get_Definition( void ) const
-{
-	return (const ScriptableGameObjDef &)BaseGameObj::Get_Definition();
-}
-
-const BuildingGameObjDef & BuildingGameObj::Get_Definition( void ) const
-{
-	return (const BuildingGameObjDef &)BaseGameObj::Get_Definition();
-}
-
-const RefineryGameObjDef & RefineryGameObj::Get_Definition( void ) const
-{
-	return (const RefineryGameObjDef &)BaseGameObj::Get_Definition();
-}
-
-#ifndef TTLE_EXPORTS
-#ifndef TT_EXPORTS
-RENEGADE_FUNCTION
-bool PowerUpGameObjDef::Grant(SmartGameObj *, PowerUpGameObj *, bool) const
-AT2(0x006F09F0,0x006EFFB0);
-#endif
-
-RENEGADE_FUNCTION
-Vector3 SCRIPTS_API Get_Color_For_Team(int teamId)
-AT2(0x006D99E0,0x006D9280);
-Vector3 DamageableGameObj::Get_Team_Color(void)
-{
-	return Get_Color_For_Team(PlayerType);
-}
-
-int SCRIPTS_API Get_Object_Type(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
-	if(!o)
-	{
-		return 0;
-	}
-	DamageableGameObj *o2 = o->As_DamageableGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return o2->Get_Player_Type();
-}
-
-void SCRIPTS_API Set_Object_Type(GameObject *obj,int type)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return;
-	}
-	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
-	if(!o)
-	{
-		return;
-	}
-	DamageableGameObj *o2 = o->As_DamageableGameObj();
-	if (!o2)
-	{
-		return;
-	}
-	o2->Set_Player_Type(type);
-}
-
-GameObject SCRIPTS_API *As_PowerUpGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	PhysicalGameObj *o2 = ((BaseGameObj *)obj)->As_PhysicalGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_PowerUpGameObj();
-}
-
-GameObject SCRIPTS_API *As_C4GameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	PhysicalGameObj *o2 = ((BaseGameObj *)obj)->As_PhysicalGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_C4GameObj();
-}
-
-GameObject SCRIPTS_API *As_BeaconGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	PhysicalGameObj *o2 = ((BaseGameObj *)obj)->As_PhysicalGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_BeaconGameObj();
-}
-
-GameObject SCRIPTS_API *As_ArmedGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	PhysicalGameObj *o2 = ((BaseGameObj *)obj)->As_PhysicalGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_ArmedGameObj();
-}
-
-GameObject SCRIPTS_API *As_SimpleGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	PhysicalGameObj *o2 = ((BaseGameObj *)obj)->As_PhysicalGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_SimpleGameObj();
-}
-
-GameObject SCRIPTS_API *As_PowerPlantGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
-	if(!o)
-	{
-		return 0;
-	}
-	BuildingGameObj *o2 = o->As_BuildingGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_PowerPlantGameObj();
-}
-
-GameObject SCRIPTS_API *As_ConstructionYardGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
-	if(!o)
-	{
-		return 0;
-	}
-	BuildingGameObj *o2 = o->As_BuildingGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_ConstructionYardGameObj();
-}
-
-GameObject SCRIPTS_API *As_SoldierFactoryGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
-	if(!o)
-	{
-		return 0;
-	}
-	BuildingGameObj *o2 = o->As_BuildingGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_SoldierFactoryGameObj();
-}
-
-GameObject SCRIPTS_API *As_VehicleFactoryGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
-	if(!o)
-	{
-		return 0;
-	}
-	BuildingGameObj *o2 = o->As_BuildingGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_VehicleFactoryGameObj();
-}
-
-GameObject SCRIPTS_API *As_AirstripGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
-	if(!o)
-	{
-		return 0;
-	}
-	BuildingGameObj *o2 = o->As_BuildingGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_AirStripGameObj();
-}
-
-GameObject SCRIPTS_API *As_WarFactoryGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
-	if(!o)
-	{
-		return 0;
-	}
-	BuildingGameObj *o2 = o->As_BuildingGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_WarFactoryGameObj();
-}
-
-GameObject SCRIPTS_API *As_RefineryGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
-	if(!o)
-	{
-		return 0;
-	}
-	BuildingGameObj *o2 = o->As_BuildingGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_RefineryGameObj();
-}
-
-GameObject SCRIPTS_API *As_ComCenterGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
-	if(!o)
-	{
-		return 0;
-	}
-	BuildingGameObj *o2 = o->As_BuildingGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_ComCenterGameObj();
-}
-
-GameObject SCRIPTS_API *As_RepairBayGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	ScriptableGameObj *o = ((BaseGameObj*)obj)->As_ScriptableGameObj();
-	if(!o)
-	{
-		return 0;
-	}
-	BuildingGameObj *o2 = o->As_BuildingGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_RepairBayGameObj();
-}
-
-GameObject SCRIPTS_API *As_ScriptableGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	return (GameObject *)((BaseGameObj *)obj)->As_ScriptableGameObj();
-}
-
-GameObject SCRIPTS_API *As_PhysicalGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	return (GameObject *)((BaseGameObj *)obj)->As_PhysicalGameObj();
-}
-
-GameObject SCRIPTS_API *As_CinematicGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	PhysicalGameObj *o2 = ((BaseGameObj *)obj)->As_PhysicalGameObj();
-	if (!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_CinematicGameObj();
-}
-
-GameObject SCRIPTS_API *As_VehicleGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	return (GameObject *)((BaseGameObj *)obj)->As_VehicleGameObj();
-}
-
-GameObject SCRIPTS_API *As_SmartGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	return (GameObject *)((BaseGameObj *)obj)->As_SmartGameObj();
-}
-
-GameObject SCRIPTS_API *As_DamageableGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	ScriptableGameObj* o2 = ((BaseGameObj *)obj)->As_ScriptableGameObj();
-	if(!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_DamageableGameObj();
-}
-
-GameObject SCRIPTS_API *As_SoldierGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	ScriptableGameObj* o2 = ((BaseGameObj *)obj)->As_ScriptableGameObj();
-	if(!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_SoldierGameObj();
-}
-
-GameObject SCRIPTS_API *As_ScriptZoneGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	ScriptableGameObj* o2 = ((BaseGameObj *)obj)->As_ScriptableGameObj();
-	if(!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_ScriptZoneGameObj();
-}
-
-GameObject SCRIPTS_API *As_BuildingGameObj(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	ScriptableGameObj* o2 = ((BaseGameObj *)obj)->As_ScriptableGameObj();
-	if(!o2)
-	{
-		return 0;
-	}
-	return (GameObject *)o2->As_BuildingGameObj();
-}
-
-bool SCRIPTS_API Is_Building(GameObject *obj)
-{
-	if (As_BuildingGameObj(obj))
-	{
-		return true;
-	}
-	return false;
-}
-
-bool SCRIPTS_API Is_Soldier(GameObject *obj)
-{
-	if (As_SoldierGameObj(obj))
-	{
-		return true;
-	}
-	return false;
-}
-
-bool SCRIPTS_API Is_Vehicle(GameObject *obj)
-{
-	if (As_VehicleGameObj(obj))
-	{
-		return true;
-	}
-	return false;
-}
-
-bool SCRIPTS_API Is_Cinematic(GameObject *obj)
-{
-	if (As_CinematicGameObj(obj))
-	{
-		return true;
-	}
-	return false;
-}
-
-bool SCRIPTS_API Is_ScriptZone(GameObject *obj)
+SCRIPTS_API const SpecialEffectsGameObjDef & SpecialEffectsGameObj::Get_Definition( void ) const
 {
-	if (As_ScriptZoneGameObj(obj))
+	return (const SpecialEffectsGameObjDef &)BaseGameObj::Get_Definition();
+}
+SCRIPTS_API const TransitionGameObjDef & TransitionGameObj::Get_Definition( void ) const
 	{
-		return true;
+	return (const TransitionGameObjDef &)BaseGameObj::Get_Definition();
 	}
-	return false;
+SCRIPTS_API const WarFactoryGameObjDef &
+WarFactoryGameObj::Get_Definition (void) const
+{
+	return (const WarFactoryGameObjDef &)BaseGameObj::Get_Definition ();
 }
 
-bool SCRIPTS_API Is_Powerup(GameObject *obj)
-{
-	if (As_PowerUpGameObj(obj))
+SCRIPTS_API const VehicleFactoryGameObjDef &
+VehicleFactoryGameObj::Get_Definition (void) const
 	{
-		return true;
-	}
-	return false;
+	return (const VehicleFactoryGameObjDef &)BaseGameObj::Get_Definition ();
 }
 
-bool SCRIPTS_API Is_C4(GameObject *obj)
+SCRIPTS_API const ScriptZoneGameObjDef & ScriptZoneGameObj::Get_Definition( void ) const
 {
-	if (As_C4GameObj(obj))
-	{
-		return true;
-	}
-	return false;
+	return (const ScriptZoneGameObjDef &)BaseGameObj::Get_Definition();
 }
 
-bool SCRIPTS_API Is_Scriptable(GameObject *obj)
-{
-	if (As_ScriptableGameObj(obj))
+unsigned char NetworkObjectClass::Get_Object_Dirty_Bits(int clientId)
 	{
-		return true;
-	}
-	return false;
+	return ClientStatus[clientId];
 }
 
-bool SCRIPTS_API Is_Beacon(GameObject *obj)
-{
-	if (As_BeaconGameObj(obj))
+bool NetworkObjectClass::Get_Object_Dirty_Bit(int clientId, DIRTY_BIT level)
 	{
-		return true;
-	}
-	return false;
+	return (ClientStatus[clientId] & level) == level;
 }
 
-bool SCRIPTS_API Is_Armed(GameObject *obj)
+void DefenseObjectClass::Set_Health_Max(float health)
 {
-	if (As_ArmedGameObj(obj))
+	HealthMax = WWMath::Clamp(health, 0, MAX_MAX_HEALTH);
+	if (HealthMax < Health)
 	{
-		return true;
+		Health = HealthMax;
 	}
-	return false;
+	Mark_Owner_Dirty();
 }
 
-bool SCRIPTS_API Is_Simple(GameObject *obj)
-{
-	if (As_SimpleGameObj(obj))
+void	DefenseObjectClass::Set_Shield_Type( ArmorType type )	
 	{
-		return true;
-	}
-	return false;
+	ShieldType = type; 
+	Mark_Owner_Dirty();
 }
 
-bool SCRIPTS_API Is_PowerPlant(GameObject *obj)
-{
-	if (As_PowerPlantGameObj(obj))
+float DefenseObjectClass::Get_Health() const
 	{
-		return true;
-	}
-	return false;
+	return this->Health;
 }
 
-bool SCRIPTS_API Is_ConstructionYard(GameObject *obj)
-{
-	if (As_ConstructionYardGameObj(obj))
+
+
+float DefenseObjectClass::Get_Health_Max() const
 	{
-		return true;
-	}
-	return false;
+	return this->HealthMax;
 }
 
-bool SCRIPTS_API Is_SoldierFactory(GameObject *obj)
-{
-	if (As_SoldierFactoryGameObj(obj))
+
+float DefenseObjectClass::Get_Shield_Strength() const
 	{
-		return true;
-	}
-	return false;
+	return this->ShieldStrength;
 }
 
-bool SCRIPTS_API Is_VehicleFactory(GameObject *obj)
-{
-	if (As_VehicleFactoryGameObj(obj))
+
+
+float DefenseObjectClass::Get_Shield_Strength_Max() const
 	{
-		return true;
-	}
-	return false;
+	return this->ShieldStrengthMax;
 }
 
-bool SCRIPTS_API Is_Airstrip(GameObject *obj)
+void DefenseObjectClass::Set_Shield_Strength_Max(float str)
 {
-	if (As_AirstripGameObj(obj))
+	ShieldStrengthMax = WWMath::Clamp(str, 0, MAX_MAX_SHIELD_STRENGTH);
+	if (ShieldStrengthMax < ShieldStrength)
 	{
-		return true;
+		ShieldStrength = ShieldStrengthMax;
 	}
-	return false;
+	Mark_Owner_Dirty();
 }
 
-bool SCRIPTS_API Is_WarFactory(GameObject *obj)
+
+
+void DefenseObjectClass::Mark_Owner_Dirty()
 {
-	if (As_WarFactoryGameObj(obj))
+	if (Get_Owner())
 	{
-		return true;
+		Get_Owner()->Set_Object_Dirty_Bit(NetworkObjectClass::BIT_OCCASIONAL, true);
 	}
-	return false;
 }
 
-bool SCRIPTS_API Is_Refinery(GameObject *obj)
+SCRIPTS_API REF_DEF3(GameObjManager::BuildingGameObjList, SList<BuildingGameObj>, 0x00856FE8, 0x008561D0, 0x0085BED0);
+SCRIPTS_API REF_DEF3(GameObjManager::GameObjList, SList<BaseGameObj>, 0x00856FF8, 0x008561E0, 0x0085BEE0);
+SCRIPTS_API REF_DEF3(GameObjManager::StarGameObjList, SList<SoldierGameObj>, 0x00856FC8, 0x008561B0, 0x0085BEB0);
+SCRIPTS_API REF_DEF3(GameObjManager::SmartGameObjList, SList<SmartGameObj>, 0x00856FD8, 0x008561C0, 0x0085BEC0);
+
+#ifdef SHADERS_EXPORTS
+SHADERS_API SList<C4GameObj> GameObjManager::C4GameObjList;
+SHADERS_API SList<BeaconGameObj> GameObjManager::BeaconGameObjList;
+SHADERS_API SList<SoldierGameObj> GameObjManager::SoldierGameObjList;
+SHADERS_API SList<VehicleGameObj> GameObjManager::VehicleGameObjList;
+SHADERS_API SList<ScriptZoneGameObj> GameObjManager::ScriptZoneGameObjList;
+#endif
+
+SCRIPTS_API const BaseGameObjDef &	BaseGameObj::Get_Definition( void ) const 
 {
-	if (As_RefineryGameObj(obj))
+	return *Definition;
+};
+
+SCRIPTS_API const DamageableGameObjDef & DamageableGameObj::Get_Definition( void ) const 
 	{
-		return true;
-	}
-	return false;
+	return (const DamageableGameObjDef &)BaseGameObj::Get_Definition();
 }
 
-bool SCRIPTS_API Is_ComCenter(GameObject *obj)
-{
-	if (As_ComCenterGameObj(obj))
+SCRIPTS_API void ScriptableGameObj::Insert_Observer( GameObjObserverClass * observer )
 	{
-		return true;
-	}
-	return false;
+	observer->Attach( this );
+	Observers.Add( observer );
 }
 
-bool SCRIPTS_API Is_RepairBay(GameObject *obj)
-{
-	if (As_RepairBayGameObj(obj))
+SCRIPTS_API void ScriptableGameObj::Remove_Observer( GameObjObserverClass * observer )
 	{
-		return true;
-	}
-	return false;
+	Observers.Delete( observer );
+	observer->Detach( this );
 }
 
-const char SCRIPTS_API *Get_Building_Type(GameObject *obj)
+SCRIPTS_API const ScriptableGameObjDef & ScriptableGameObj::Get_Definition( void ) const
 {
-	if (Is_PowerPlant(obj))
+	return (const ScriptableGameObjDef &)BaseGameObj::Get_Definition();
+}
+
+SCRIPTS_API const BuildingGameObjDef & BuildingGameObj::Get_Definition( void ) const
 	{
-		return "Is_PowerPlant";
+	return (const BuildingGameObjDef &)BaseGameObj::Get_Definition();
 	}
-	else if (Is_ConstructionYard(obj))
+
+SCRIPTS_API const RefineryGameObjDef & RefineryGameObj::Get_Definition( void ) const
 	{
-		return "Is_ConstructionYard";
+	return (const RefineryGameObjDef &)BaseGameObj::Get_Definition();
 	}
-	else if (Is_SoldierFactory(obj))
+
+#ifndef TTLE_EXPORTS
+#ifndef TT_EXPORTS
+RENEGADE_FUNCTION
+bool PowerUpGameObjDef::Grant(SmartGameObj *, PowerUpGameObj *, bool) const
+AT2(0x006F09F0,0x006EFFB0);
+#endif
+
+RENEGADE_FUNCTION
+Vector3 SCRIPTS_API Get_Color_For_Team(int teamId)
+AT2(0x006D99E0,0x006D9280);
+Vector3 DamageableGameObj::Get_Team_Color(void)
 	{
-		return "Is_SoldierFactory";
+	return Get_Color_For_Team(PlayerType);
 	}
-	else if (Is_VehicleFactory(obj))
+
+int SCRIPTS_API Get_Object_Type(GameObject *obj)
 	{
-		if (Is_Airstrip(obj))
+	if (!obj)
 		{
-			return "Is_Airstrip";
+		return 0;
 		}
-		else if (Is_WarFactory(obj))
+	DamageableGameObj *o2 = obj->As_DamageableGameObj();
+	if (!o2)
 		{
-			return "Is_WarFactory";
-		}
+		return 0;
 	}
-	else if (Is_Refinery(obj))
-	{
-		return "Is_Refinery";
+	return o2->Get_Player_Type();
 	}
-	else if (Is_ComCenter(obj))
+
+void SCRIPTS_API Set_Object_Type(GameObject *obj,int type)
 	{
-		return "Is_ComCenter";
-	}
-	else if (Is_RepairBay(obj))
+	if (!obj)
 	{
-		return "Is_RepairBay";
+		return;
 	}
-	else
+	DamageableGameObj *o2 = obj->As_DamageableGameObj();
+	if (!o2)
 	{
-		return "(null)";
+		return;
 	}
-	return "(null)";
+	o2->Set_Player_Type(type);
 }
 
 void SCRIPTS_API Get_Object_Color(GameObject *obj, unsigned int *red, unsigned int *green, unsigned int *blue)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	DamageableGameObj *o = (DamageableGameObj *)As_DamageableGameObj(obj);
+	DamageableGameObj *o = obj->As_DamageableGameObj();
 	if (!o)
 	{
 		return;
@@ -911,7 +338,7 @@
 	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_SmartGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if (Get_Object_Type(o) == Team)
@@ -929,12 +356,17 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			if (Get_Object_Type(o) == Team)
+			if (Get_Object_Type(o2) == Team)
 			{
-				return o;
+				return o2;
 			}
 		}
 		x = x->Next();
@@ -947,7 +379,7 @@
 	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_SmartGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if ((Get_Object_Type(o) == Team) && (!Commands->Is_A_Star(o)))
@@ -965,15 +397,20 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			const DefinitionClass *d = Get_Definition(o);
+			const DefinitionClass *d = &o2->Get_Definition();
 			if (!_stricmp(d->Get_Name(),Preset_Name))
 			{
-				if ((Get_Object_Type(o) == Team) || (Team == 2))
+				if ((Get_Object_Type(o2) == Team) || (Team == 2))
 				{
-					return o;
+					return o2;
 				}
 			}
 		}
@@ -989,17 +426,22 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			if ((Get_Object_Type(o) == Team) && !Is_Building(o))
+			if ((Get_Object_Type(o2) == Team) && !o2->As_BuildingGameObj())
 			{
-				Vector3 pos = Commands->Get_Position(o);
+				Vector3 pos = Commands->Get_Position(o2);
 				float dist = Commands->Get_Distance(pos,position);
 				if (dist < closestdist)
 				{
 					closestdist = dist;
-					closest = o;
+					closest = o2;
 				}
 			}
 		}
@@ -1015,16 +457,21 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
 		{
-			if ((Get_Object_Type(o) == Team || Team == 2) && !_stricmp(Commands->Get_Preset_Name(o),Preset))
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
+		{
+			if ((Get_Object_Type(o2) == Team || Team == 2) && !_stricmp(Commands->Get_Preset_Name(o2),Preset))
 			{
-				float dist = Commands->Get_Distance(Commands->Get_Position(o),pos);
+				float dist = Commands->Get_Distance(Commands->Get_Position(o2),pos);
 				if (dist < closestdist)
 				{
 					closestdist = dist;
-					closest = o;
+					closest = o2;
 				}
 			}
 		}
@@ -1039,12 +486,17 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
 		{
-			if ((Get_Object_Type(o) == Team || Team == 2) && !_stricmp(Commands->Get_Preset_Name(o),Preset))
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
+		{
+			if ((Get_Object_Type(o2) == Team || Team == 2) && !_stricmp(Commands->Get_Preset_Name(o2),Preset))
 			{
-				ObjList.Add(o);
+				ObjList.Add(o2);
 			}
 		}
 		x = x->Next();
@@ -1086,12 +538,17 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
 		{
-			if ((Get_Object_Type(o) == Team || Team == 2) && !_stricmp(Commands->Get_Preset_Name(o),Preset))
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
+		{
+			if ((Get_Object_Type(o2) == Team || Team == 2) && !_stricmp(Commands->Get_Preset_Name(o2),Preset))
 			{
-				ObjList->Add(o);
+				ObjList->Add(o2);
 			}
 		}
 		x = x->Next();
@@ -1105,23 +562,28 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			if (!_stricmp(Commands->Get_Preset_Name(o),preset))
+			if (!_stricmp(Commands->Get_Preset_Name(o2),preset))
 			{
 				if (object)
 				{
 					Vector3 obj_pos = Commands->Get_Position(object);
-					Vector3 o_pos = Commands->Get_Position(o);
+					Vector3 o_pos = Commands->Get_Position(o2);
 					if (Commands->Get_Distance(position, o_pos) < Commands->Get_Distance(position, obj_pos))
 					{
-						object = o;
+						object = o2;
 					}
 				}
 				else
 				{
-					object = o;
+					object = o2;
 				}
 			}
 		}
@@ -1137,12 +599,17 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (count > 0)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			if (!_stricmp(Commands->Get_Preset_Name(o),preset))
+			if (!_stricmp(Commands->Get_Preset_Name(o2),preset))
 			{
-				object = o;
+				object = o2;
 				count--;
 			}
 		}
@@ -1164,14 +631,14 @@
 
 void SCRIPTS_API Send_Custom_To_Team_Buildings(int Team,GameObject *sender,int type,int param,float delay)
 {
-	if (!Commands->Get_ID(sender) || !sender)
+	if (!sender)
 	{
 		return;
 	}
 	SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_BuildingGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if (Get_Object_Type(o) == Team)
@@ -1190,21 +657,26 @@
 
 void SCRIPTS_API Send_Custom_To_Team_Preset(int Team,const char *PresetName,GameObject *sender,int type,int param,float delay)
 {
-	if (!Commands->Get_ID(sender) || !sender)
+	if (!sender)
 	{
 		return;
 	}
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			if (Get_Object_Type(o) == Team)
+			if (Get_Object_Type(o2) == Team)
 			{
-				if (!_stricmp(Commands->Get_Preset_Name(o),PresetName))
+				if (!_stricmp(Commands->Get_Preset_Name(o2),PresetName))
 				{
-					Commands->Send_Custom_Event(sender,o,type,param,delay);
+					Commands->Send_Custom_Event(sender,o2,type,param,delay);
 				}
 			}
 		}
@@ -1214,25 +686,30 @@
 
 void SCRIPTS_API Send_Custom_All_Objects_Area(int type,const Vector3 &Position,float Distance,GameObject *sender,int team)
 {
-	if (!Commands->Get_ID(sender) || !sender)
+	if (!sender)
 	{
 		return;
 	}
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x) 
 	{
-		GameObject *obj = (GameObject *)x->Data();
-		if (obj && As_ScriptableGameObj(obj))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			Vector3 ObjPosition = Commands->Get_Position(obj);
+			Vector3 ObjPosition = Commands->Get_Position(o2);
 			Vector3 TestPosition = Position;
 			ObjPosition.Z = 0;
 			TestPosition.Z = 0;
 			if ((Commands->Get_Distance(ObjPosition,TestPosition) <= Distance))
 			{
-				if ((Get_Object_Type(obj) == team) || (team == 2))
+				if ((Get_Object_Type(o2) == team) || (team == 2))
 				{
-					Commands->Send_Custom_Event(sender,obj,type,0,0);
+					Commands->Send_Custom_Event(sender,o2,type,0,0);
 				}
 			}
 		}
